diff --git a/src/filebuf.c b/src/filebuf.c
index d23bcc11c9d..4ddc4f9dfe0 100644
--- a/src/filebuf.c
+++ b/src/filebuf.c
@@ -56,9 +56,9 @@ static int lock_file(git_filebuf *file, int flags, mode_t mode)
 	/* create path to the file buffer is required */
 	if (flags & GIT_FILEBUF_FORCE) {
 		/* XXX: Should dirmode here be configurable? Or is 0777 always fine? */
-		file->fd = git_futils_creat_locked_withpath(file->path_lock, 0777, mode);
+		file->fd = git_futils_creat_locked_withpath(file->path_lock, 0777, mode, flags & GIT_FILEBUF_RDWR);
 	} else {
-		file->fd = git_futils_creat_locked(file->path_lock, mode);
+		file->fd = git_futils_creat_locked(file->path_lock, mode, flags & GIT_FILEBUF_RDWR);
 	}
 
 	if (file->fd < 0)
diff --git a/src/filebuf.h b/src/filebuf.h
index 044af5405c0..6143156cb8d 100644
--- a/src/filebuf.h
+++ b/src/filebuf.h
@@ -20,7 +20,8 @@
 #define GIT_FILEBUF_FORCE				(1 << 3)
 #define GIT_FILEBUF_TEMPORARY			(1 << 4)
 #define GIT_FILEBUF_DO_NOT_BUFFER		(1 << 5)
-#define GIT_FILEBUF_DEFLATE_SHIFT		(6)
+#define GIT_FILEBUF_RDWR				(1 << 6)
+#define GIT_FILEBUF_DEFLATE_SHIFT		(7)
 
 #define GIT_FILELOCK_EXTENSION ".lock\0"
 #define GIT_FILELOCK_EXTLENGTH 6
diff --git a/src/fileops.c b/src/fileops.c
index 13b8f6a39fe..269a55b41ec 100644
--- a/src/fileops.c
+++ b/src/fileops.c
@@ -63,9 +63,9 @@ int git_futils_creat_withpath(const char *path, const mode_t dirmode, const mode
 	return fd;
 }
 
-int git_futils_creat_locked(const char *path, const mode_t mode)
+int git_futils_creat_locked(const char *path, const mode_t mode, bool rdwr)
 {
-	int fd = p_open(path, O_WRONLY | O_CREAT | O_TRUNC |
+	int fd = p_open(path, (rdwr ? O_RDWR : O_WRONLY) | O_CREAT | O_TRUNC |
 		O_EXCL | O_BINARY | O_CLOEXEC, mode);
 
 	if (fd < 0) {
@@ -76,12 +76,12 @@ int git_futils_creat_locked(const char *path, const mode_t mode)
 	return fd;
 }
 
-int git_futils_creat_locked_withpath(const char *path, const mode_t dirmode, const mode_t mode)
+int git_futils_creat_locked_withpath(const char *path, const mode_t dirmode, const mode_t mode, bool rdwr)
 {
 	if (git_futils_mkpath2file(path, dirmode) < 0)
 		return -1;
 
-	return git_futils_creat_locked(path, mode);
+	return git_futils_creat_locked(path, mode, rdwr);
 }
 
 int git_futils_open_ro(const char *path)
diff --git a/src/fileops.h b/src/fileops.h
index 62227abaee6..c37a15c4d51 100644
--- a/src/fileops.h
+++ b/src/fileops.h
@@ -44,13 +44,13 @@ extern int git_futils_creat_withpath(const char *path, const mode_t dirmode, con
 /**
  * Create an open a process-locked file
  */
-extern int git_futils_creat_locked(const char *path, const mode_t mode);
+extern int git_futils_creat_locked(const char *path, const mode_t mode, bool rdwr);
 
 /**
  * Create an open a process-locked file, while
  * also creating all the folders in its path
  */
-extern int git_futils_creat_locked_withpath(const char *path, const mode_t dirmode, const mode_t mode);
+extern int git_futils_creat_locked_withpath(const char *path, const mode_t dirmode, const mode_t mode, bool rdwr);
 
 /**
  * Create a path recursively
diff --git a/src/win32/posix_w32.c b/src/win32/posix_w32.c
index 0d070f6b59e..63ae0494ef9 100644
--- a/src/win32/posix_w32.c
+++ b/src/win32/posix_w32.c
@@ -569,7 +569,7 @@ int p_mkstemp(char *tmp_path)
 		return -1;
 #endif
 
-	return p_creat(tmp_path, 0744); //-V536
+	return p_open(tmp_path, O_RDWR | O_CREAT | O_TRUNC | O_EXCL, 0600);
 }
 
 int p_access(const char* path, mode_t mode)
